package cn.cecep.talroad.controller;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;
import cn.cecep.talroad.domain.PcProductionFacility;
import cn.cecep.talroad.service.IPcProductionFacilityService;
import cn.cecep.talroad.vo.PcProductionFacilityVo;
import cn.cecep.talroad.vo.query.PcProductionFacilityQuery;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.security.InvalidParameterException;
import java.util.Arrays;
import java.util.List;


/**
 * * 开发公司：中节能天融科技有限公司
 * 生产设施Controller 控制层
 *
 * @author szhpt
 * @date 2023-01-10*/
@Api(tags = "生产设施")
@RestController
@RequestMapping("/pcProductionFacility")
public class PcProductionFacilityController extends BasesController
{
    @Autowired
    private IPcProductionFacilityService pcProductionFacilityService;

    /**
     * 查询生产设施列表
     */
    @ApiOperation(value = "查询生产设施")
    @GetMapping("/list")
    public AjaxResults<IPage<PcProductionFacility>> list(PcProductionFacilityQuery pcProductionFacility)
    {
        Page<PcProductionFacility> page = new Page<>(pcProductionFacility.getPageNum(), pcProductionFacility.getPageSize());
        IPage<PcProductionFacility> list = pcProductionFacilityService.page(page, PcProductionFacilityQuery.createLambdaQueryWrapper(pcProductionFacility));
        return AjaxResults.success(list);
    }
    

    /**
     * 导出生产设施列表
     */
    @ApiOperation(value = "导出生产设施")
    @Log(title = "生产设施", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, PcProductionFacility pcProductionFacility)
    {
        List<PcProductionFacility> list = pcProductionFacilityService.selectPcProductionFacilityList(pcProductionFacility);
        ExcelUtil<PcProductionFacility> util = new ExcelUtil<PcProductionFacility>(PcProductionFacility.class);
        util.exportExcel(response, list, "生产设施数据");
    }

    /**
     * 获取生产设施详细信息
     */
    @ApiOperation(value = "获取生产设施详细信息")
    @PostMapping(value = "/{id}")
    public AjaxResults<PcProductionFacility> getInfo(@PathVariable("id") Integer id) {
        return AjaxResults.success(pcProductionFacilityService.getById(id));
    }
    /**
     * 新增生产设施
     */
    @ApiOperation(value = "新增生产设施")
    @Log(title = "生产设施", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody PcProductionFacility pcProductionFacility) {
        return toAjax(pcProductionFacilityService.save(pcProductionFacility));
    }
    /**
     * 修改生产设施
     */
    @ApiOperation(value = "修改生产设施")
    @Log(title = "生产设施", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody PcProductionFacilityVo pcProductionFacilityVo) {
        if(ObjectUtil.isEmpty(pcProductionFacilityVo)){
            throw new InvalidParameterException("参数为空");
        }
        if(ObjectUtil.isEmpty(pcProductionFacilityVo.getId())){
            throw new InvalidParameterException("参数id为空");
        }
        PcProductionFacility pcProductionFacility = pcProductionFacilityService.getById(pcProductionFacilityVo.getId());
        if(ObjectUtil.isEmpty(pcProductionFacility)){
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", pcProductionFacilityVo.getId()));
        }
        //赋值
        BeanUtil.copyProperties(pcProductionFacilityVo,pcProductionFacility);
        return toAjax(pcProductionFacilityService.saveOrUpdate(pcProductionFacility));
    }

    /**
     * 删除生产设施
     */
    @ApiOperation(value = "删除生产设施")
    @RequiresPermissions("talroad:facility:remove")
    @Log(title = "生产设施", businessType = BusinessType.DELETE)
    @PostMapping("/{ids}")
    public AjaxResults<Boolean> remove(@PathVariable String[] ids) {
        return toAjax(pcProductionFacilityService.removeByIds(Arrays.asList(ids)));
    }
}
